package fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile;

import javax.xml.stream.XMLStreamWriter;

import fr.inra.pappso.libodsstream.OdsDocWriterInterface;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;

public interface IdentificationDataSource extends
		Comparable<IdentificationDataSource> {
	public String getName() throws MSMSException;

	public String getSampleName() throws MSMSException;

	public Identification loadIdentification(
			Identification previousIdentification) throws Exception;

	public Identification loadPhosphoIdentification(
			Identification previousIdentification) throws Exception;

	public boolean loadMSMSSpectra(Peptide pep) throws Exception;

	public void writeXpipPeptideSourceAttribute(XMLStreamWriter writer)
			throws Exception;

	@Override
	public int compareTo(IdentificationDataSource toCompare);

	public boolean equals(Object o);

	public boolean exists();

	/**
	 * store scan number correspondance information
	 *
	 * this is usefull in case the real scan num (given by the spectrometer) is
	 * not the same as indicated in the identification data source : one can
	 * store the fuzzy scan number and still can get MSMS data from the source
	 *
	 */
	public void setScanCorrespondance(int fixedScanNum,
			int scanNumAsWrittenInDataSource);

	/**
	 * gets the identifier of the spectrum within this datasource, given the
	 * real spectrum scan number
	 *
	 * @param scanNumber
	 * @return NULL if there is no correspondance
	 */
	public Integer getScanCorrespondance(int scanNumber);

	void writeOdsInformations(OdsDocWriterInterface odsTable)
			throws MSMSException;

}
