package fr.inra.pappso.xtandempipeline.class_msms;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.grouping.interfaces.GrpPhosphoModif;

public class Modifs implements Comparable<Modifs>, Serializable,
		GrpPhosphoModif {
	private static final Logger logger = Logger.getLogger(Modifs.class);

	/**
	 *
	 */
	private static final long serialVersionUID = 676496558355723927L;
	private String AA;
	private int posi;
	private int posi_in_prot;
	private float modvalue;
	private boolean isotopic;

	/**
	 * Private method, same signature as in Serializable interface
	 * 
	 * @param stream
	 * @throws IOException
	 */
	private void writeObject(ObjectOutputStream stream) throws IOException {
		logger.debug("writeObject begin");
		stream.writeObject("coucou");
	}

	private void readObject(ObjectInputStream stream) throws IOException,
			ClassNotFoundException {
		AA = (String) stream.readObject();
	}

	// constructeur
	public Modifs(float _modvalue) {
		this.modvalue = _modvalue;
		this.isotopic = false;
	}

	public Modifs(String _AA, int _posi, float _modvalue) {
		this.AA = _AA;
		this.posi = _posi;
		this.modvalue = _modvalue;
		this.isotopic = false;
		this.posi_in_prot = 0;
	}

	public int compareTo(Modifs p) {
		int k = (int) ((this.modvalue - p.get_modvalue()) * 100);
		return (k);
	}

	public String get_AA() {
		return (this.AA);
	}

	public int get_posi() {
		return (this.posi);
	}

	public float get_modvalue() {
		return (this.modvalue);
	}

	public String get_formater_value() {
		String f = this.AA + this.posi;
		if (this.modvalue > 0)
			f = f + ":+" + this.modvalue;
		else
			f = f + ":" + this.modvalue;
		return (f);
	}

	public boolean is_phopho_modifs() {
		if ((this.modvalue > 79.9) & (this.modvalue < 80.1))
			return true;
		boolean serthre = false;
		if (this.AA.equals("T"))
			serthre = true;
		else if (this.AA.equals("S"))
			serthre = true;
		if ((serthre) & (this.modvalue < -17.9) & (this.modvalue > -18.1))
			return true;
		return false;
	}

	public void setIsotopic(boolean isotopic) {
		this.isotopic = isotopic;
	}

	public boolean isIsotopic() {
		return isotopic;
	}

	public String toString() {
		if (modvalue == 0)
			return ("No isotope labelling");
		return ("" + modvalue);
	}

	public void setPosi_in_prot(int posi_in_prot) {
		this.posi_in_prot = posi_in_prot;
	}

	@Override
	public int getPosi_in_prot() {
		return posi_in_prot;
	}

	public boolean isNter() {
		if (this.posi == 1) {
			return true;
		}
		return false;
	}
}