package fr.inra.pappso.xtandempipeline.sax_parse;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import fr.inra.pappso.xtandempipeline.class_msms.xtandem_param;

public class HandlerXtModelFile extends SaxBaseHandler {

	private static final Logger logger = Logger
			.getLogger(HandlerXtModelFile.class);

	private xtandem_params params;

	private xtandem_param param_;

	private boolean valid_param;

	public HandlerXtModelFile(xtandem_params p) {
		this.params = p;
	}

	@Override
	public void startDocument() throws SAXException {
		valid_param = false;
	}

	@Override
	public void endDocument() throws SAXException {

	}

	public void startElementnote(String nameSpaceUri, Attributes attrs) {
		if ((attrs.getValue("type") != null)
				&& attrs.getValue("type").equals("input")) {
			// Modification de l'erreur de balise refine
			if (attrs.getValue("label").equalsIgnoreCase("refine, refine")) {
				param_ = params.get_param_to("refine");
				logger.debug("modified refine bug");
			} else {
				param_ = params.get_param_to(attrs.getValue("label"));
			}

			if (param_ != null && param_.isModified()) {
				valid_param = true;
			}
		}

	}

	public void endElementnote(String nameSpaceUri, String data) {
		if (valid_param) {
			param_.setValue(data);
			logger.debug(param_.xmlvalue() + " : " + data);
			valid_param = false;
		}
	}

}
