package fr.inra.pappso.xtandempipeline.sax_parse;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import fr.inra.pappso.xtandempipeline.class_msms.xtandem_param;

public class HandlerXtModelFile4newParams extends SaxBaseHandler {

	private static final Logger logger = Logger
			.getLogger(HandlerXtModelFile4newParams.class);

	private xtandem_params params;

	private xtandem_param param_;

	public HandlerXtModelFile4newParams(xtandem_params p) {
		this.params = p;
	}

	@Override
	public void startDocument() throws SAXException {
		logger.info("Create new xtamde param");
	}

	@Override
	public void endDocument() throws SAXException {

	}

	public void startElementparam(String nameSpaceUri, Attributes attrs) {
		// <model>
		// <param group="spectrum" link="/resources/spmmeu.html" mod="yes"
		// type="ppm|Daltons"
		// label="spectrum, parent monoisotopic mass error units"
		// note="parent ion M+H mass tolerance window units" >ppm</param>
		param_ = new xtandem_param();
		param_.setGroup(attrs.getValue("group"));
		param_.setLabel(attrs.getValue("label"));
		param_.setNote(attrs.getValue("note"));
		param_.setType(attrs.getValue("type"));
		// try {
		// param_.setLink(new URL(attrs.getValue("link")));
		// } catch (MalformedURLException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
		param_.setLink(attrs.getValue("link"));

		if (attrs.getValue("mod").equalsIgnoreCase("no"))
			param_.setModified(false);
		else
			param_.setModified(true);

	}

	public void endElementparam(String nameSpaceUri, String data) {
		param_.setDefault_value(data);
		params.add_params(param_);
		logger.debug(param_.getGroup() + "-" + param_.getLabel() + " : "
				+ param_.getValue());
	}

}
