package fr.inra.pappso.xtandempipeline.sax_parse;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLReaderFactory;
import org.apache.log4j.Logger;
import org.apache.xerces.impl.io.MalformedByteSequenceException;
import fr.inra.moulon.utils.MyErrorHandler;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;

public class parse_file {
	private static final Logger logger = Logger.getLogger(parse_file.class);

	// private SaxBaseHandler handler;

	// private SAXParserFactory factory;

	// private SAXParser saxParser;

	// private File file_to_parse;

	public parse_file(SaxBaseHandler h, File f) throws MSMSException {
		logger.debug("parse_file begin");
		// on recupere le handler et le fichier à parser
		SaxBaseHandler handler = h;
		File file_to_parse = f;
		logger.info("Parsing xml file : " + f.getName());
		if (!file_to_parse.exists())
			throw new MSMSException("The file "
					+ file_to_parse.getAbsolutePath()
					+ " doesn't exist : no parsing possible");

		org.xml.sax.XMLReader saxParser;
		try {
			saxParser = XMLReaderFactory.createXMLReader();
		} catch (SAXException e) {
			e.printStackTrace();
			throw new MSMSException("ERROR creating XMLReaderFactory "
					+ e.getMessage());
		}
		saxParser.setContentHandler(handler);
		saxParser.setErrorHandler(new MyErrorHandler());

		// this.factory = SAXParserFactory.newInstance();
		// this.saxParser = factory.newSAXParser();
		try {
			try {
				InputStream inputStream = new FileInputStream(file_to_parse);
				InputSource is = new InputSource(inputStream);

				saxParser.parse(is);
				inputStream.close();
				// this.saxParser.parse(is, this.handler);
			} catch (MalformedByteSequenceException e) {
				try {
					logger.debug("Mauvais encodage");
					InputStream inputStream = new FileInputStream(file_to_parse);
					InputSource is = new InputSource(inputStream);
					is.setEncoding("ISO-8859-1");
					saxParser.parse(is);
					inputStream.close();
				} catch (Exception e2) {
					throw e2;
				}

			} catch (Exception e3) {
				throw e3;
			}
		} catch (SAXException e) {

			String message = "Error reading xml file "
					+ file_to_parse.getAbsolutePath() + ":\n " + e.getMessage();
			if (e.getException() != null) {
				message += "\n reason : " + e.getException().getMessage();
			}
			e.printStackTrace();
			logger.error("Exception class : " + e.getClass().getCanonicalName());
			logger.error(message);
			throw new MSMSException(message);
		} catch (Exception e) {
			String message = "Error reading xml file "
					+ file_to_parse.getAbsolutePath() + " " + e.getMessage();

			e.printStackTrace();
			logger.error("Exception class : " + e.getClass().getCanonicalName());
			logger.error(message);

			throw new MSMSException(message);
		}
	}

	public parse_file(SaxBaseHandler h, InputStream input) throws MSMSException {
		// on recupere le handler et le fichier à parser
		logger.debug("parse_file for inputStream begin");
		if (h == null) {
			throw new MSMSException("handler is null");
		}
		SaxBaseHandler handler = h;

		org.xml.sax.XMLReader saxParser;
		try {
			saxParser = XMLReaderFactory.createXMLReader();
			saxParser.setFeature("http://apache.org/xml/features/nonvalidating/load-external-dtd", false);
		} catch (SAXException e) {
			e.printStackTrace();
			throw new MSMSException("ERROR creating XMLReaderFactory "
					+ e.getMessage());
		}
		saxParser.setContentHandler(handler);
		saxParser.setErrorHandler(new MyErrorHandler());

		try {
			InputSource is = new InputSource(input);
			saxParser.parse(is);
			input.close();
		} catch (SAXException e) {

			String message = "Error reading xml input " + e.getMessage();
			if (e.getException() != null) {
				message += "\n reason : " + e.getException().getMessage();
			}
			logger.error(message);
			throw new MSMSException(message);
		} catch (Exception e) {
			String message = "Error reading xml input " + e.getMessage();
			logger.error(message);
			throw new MSMSException(message);
		}
	}

}
