package fr.inra.pappso.xtandempipeline.ui.swt;

import java.io.File;

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import fr.inra.pappso.xtandempipeline.XtandemPipelineSession;
import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.Modifs;
import fr.inra.pappso.xtandempipeline.class_msms.ModifsList;
import fr.inra.pappso.xtandempipeline.filter_print.print_fasta;
import fr.inra.pappso.xtandempipeline.filter_print.print_fasta_to_group;
import fr.inra.pappso.xtandempipeline.filter_print.print_fasta_to_subgroup;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;

public class Export_Windows {
	private static final Logger logger = Logger.getLogger(Export_Windows.class);

	protected config conf;

	private Shell shell;

	private Button choice_spreadsheet_export;

	private Button choice_expert_spreadsheet_export;

	private Button choice_fasta_export;

	private Button choice_protic_export;

	private Button choice_quantimscpp_export;

	private Button choice_fdr_export;

	private Button choice_pepnovo_export;

	private boolean Cancelled;

	private DataType_Base datatype;

	private File out;

	private Button next;

	protected Combo fasta_type;

	protected Combo spreadsheet_type;

	protected Button setisotopelabel;

	public Export_Windows(Main_Windows controlleur) {
		this.conf = XtandemPipelineSession.getInstance().getConfig();
		this.datatype = XtandemPipelineSession.getInstance().getDataTypeBase();
		this.Cancelled = true;
		// initialise la fenetre
		shell = new Shell(controlleur.getDisplay(), SWT.DIALOG_TRIM
				| SWT.APPLICATION_MODAL);
		shell.setImages(controlleur.getImages());
		init();

		shell.pack();
		// shell.setSize(500, 600);
		shell.open();
		while (!shell.isDisposed()) {
			if (!controlleur.getDisplay().readAndDispatch()) {
				controlleur.getDisplay().sleep();
			}
		}
	}

	private void init() {
		shell.setText("Export settings");
		GridLayout layout = new GridLayout(1, false);
		layout.marginLeft = layout.marginTop = layout.marginRight = layout.marginBottom = 10;
		layout.verticalSpacing = 10;
		shell.setLayout(layout);

		Group fileout = new Group(shell, SWT.SHADOW_IN);
		fileout.setText("Save results as");
		// data = new GridData(GridData.FILL_HORIZONTAL);
		// data.horizontalSpan=2;
		// add_xtandem.setLayoutData(data);
		fileout.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		fileout.setLayout(new GridLayout(2, false));

		Text set_out = new Text(fileout, SWT.SINGLE | SWT.READ_ONLY);
		set_out.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		set_out.setText("No selected");
		Button set = new Button(fileout, SWT.PUSH);
		set.setText("Save as");
		set.setData("text", set_out);
		set.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Export_Windows.this.setFileout((Button) e.widget);
			}
		});

		Group group = new Group(shell, SWT.SHADOW_IN);
		group.setText("Export");
		group.setData(new GridData(GridData.FILL_HORIZONTAL));
		group.setLayout(new GridLayout(1, false));

		// all.setEnabled(false);
		choice_spreadsheet_export = new Button(group, SWT.CHECK);
		choice_spreadsheet_export
				.setText("Peptide, protein and compar results as spreadsheet");
		this.spreadsheet_type = new Combo(group, SWT.DROP_DOWN | SWT.READ_ONLY);
		spreadsheet_type.setLayoutData(new GridData(
				GridData.HORIZONTAL_ALIGN_CENTER));
		if (conf.get_export_ods() || conf.get_export_txt()) {
			logger.debug("export spreadsheet enabled");
			spreadsheet_type.setEnabled(true);
			choice_spreadsheet_export.setSelection(true);
		} else {
			spreadsheet_type.setEnabled(false);
			choice_spreadsheet_export.setSelection(false);
		}
		this.populateSpreadsheetExportCombo();
		choice_spreadsheet_export.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				logger.debug("Change spreadsheet export");
				Button b = (Button) e.widget;
				if (b.getSelection()) {
					Export_Windows.this.spreadsheet_type.setEnabled(true);
					Export_Windows.this.updateSpreadsheetType();
					Export_Windows.this.choice_expert_spreadsheet_export
							.setEnabled(true);
				} else {
					Export_Windows.this.spreadsheet_type.setEnabled(false);
					Export_Windows.this.updateSpreadsheetType();
					Export_Windows.this.choice_expert_spreadsheet_export
							.setEnabled(false);
				}
			}
		});

		choice_expert_spreadsheet_export = new Button(group, SWT.CHECK);
		choice_expert_spreadsheet_export.setText("expert spreadsheet output");
		choice_expert_spreadsheet_export.setSelection(conf
				.get_export_expert_spreadsheet());
		if (this.choice_spreadsheet_export.getSelection()) {
			this.choice_expert_spreadsheet_export.setEnabled(true);
		} else {
			this.choice_expert_spreadsheet_export.setEnabled(false);
		}

		choice_fasta_export = new Button(group, SWT.CHECK);
		choice_fasta_export.setText("Identified proteins to a fasta file");
		choice_fasta_export.setSelection(conf.get_export_fasta());
		this.fasta_type = new Combo(group, SWT.DROP_DOWN | SWT.READ_ONLY);
		fasta_type
				.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
		fasta_type.setEnabled(conf.get_export_fasta());
		this.defined_fasta_export_combo();
		choice_fasta_export.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				logger.debug("Change fasta export");
				Button b = (Button) e.widget;
				if (b.getSelection())
					Export_Windows.this.fasta_type.setEnabled(true);
				else
					Export_Windows.this.fasta_type.setEnabled(false);
			}
		});

		choice_fdr_export = new Button(group, SWT.CHECK);
		choice_fdr_export
				.setText("Peptide and protein evalue distribution for FDR");
		choice_fdr_export.setSelection(conf.get_Export_fdr());

		choice_pepnovo_export = new Button(group, SWT.CHECK);
		choice_pepnovo_export.setText("Results for further PepNovo analysis");
		choice_pepnovo_export.setSelection(conf.get_export_pepnovo());

		choice_quantimscpp_export = new Button(group, SWT.CHECK);
		choice_quantimscpp_export
				.setText("Results for further quantification by MassChroQ");
		choice_quantimscpp_export.setSelection(conf.get_export_masschroq());

		this.setisotopelabel = new Button(group, SWT.PUSH);
		setisotopelabel.setLayoutData(new GridData(
				GridData.HORIZONTAL_ALIGN_CENTER));
		setisotopelabel.setText("Defined isotope labelling");
		setisotopelabel.setEnabled(conf.get_export_masschroq());
		setisotopelabel.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Export_Windows.this.defined_isotope_label();
			}
		});
		choice_quantimscpp_export.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				logger.debug("Change isotope export");
				Button b = (Button) e.widget;
				if (b.getSelection())
					Export_Windows.this.setisotopelabel.setEnabled(true);
				else
					Export_Windows.this.setisotopelabel.setEnabled(false);
			}
		});

		choice_protic_export = new Button(group, SWT.CHECK);
		choice_protic_export
				.setText("Identification results to import in PROTICdb");
		choice_protic_export.setSelection(conf.get_export_proticdbml());

		Label separator = new Label(shell, SWT.SEPARATOR | SWT.HORIZONTAL);
		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		separator.setLayoutData(data);

		next = new Button(shell, SWT.PUSH);
		next.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		next.setText("Export");
		next.setEnabled(false);
		next.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				Export_Windows.this.next_clic();
			}
		});
		// on desable certain export si individual
		if (datatype.getIs_invididual()) {
			choice_quantimscpp_export.setEnabled(false);
			choice_fdr_export.setEnabled(false);
			choice_quantimscpp_export.setSelection(false);
			choice_fdr_export.setSelection(false);
			setisotopelabel.setEnabled(false);
		}

	}

	protected void defined_isotope_label() {
		final Shell shell2 = new Shell(shell, SWT.DIALOG_TRIM
				| SWT.APPLICATION_MODAL);
		shell2.setLayout(new GridLayout(1, false));
		Group mods = new Group(shell2, SWT.SHADOW_IN);
		mods.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		mods.setLayout(new FillLayout());
		mods.setText("Select isotopic modifications");
		List list = new List(mods, SWT.MULTI);
		list.add("No labelling");
		final Modifs[] all_mods = XtandemPipelineSession.getInstance()
				.getIdentificationList().get(0).get_modifs_liste()
				.get_modifs_order();
		for (Modifs modifs : all_mods) {
			list.add("" + modifs.get_modvalue());
		}
		Label l = new Label(shell2, SWT.SEPARATOR | SWT.HORIZONTAL);
		l.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Button ok = new Button(shell2, SWT.PUSH);
		ok.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_END));
		ok.setData("list", list);
		ok.setData("mods", all_mods);
		ok.setText("OK");
		ok.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				List list = (List) e.widget.getData("list");
				Modifs[] all_mods = (Modifs[]) e.widget.getData("mods");
				ModifsList mls = new ModifsList();
				for (int index : list.getSelectionIndices())
					if (index != 0)
						mls.add_modifs(all_mods[index - 1]);
				try {
					Export_Windows.this.datatype.getPrint().setIsotopic_mods(
							mls);
				} catch (MSMSException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					String message = "error in export windows "
							+ e1.getMessage();
					logger.error(message);
				}
				shell2.dispose();
			}
		});
		shell2.pack();
		shell2.open();
		while (!shell2.isDisposed()) {
			if (!shell.getDisplay().readAndDispatch()) {
				shell.getDisplay().sleep();
			}
		}
	}

	private void populateSpreadsheetExportCombo() {
		this.spreadsheet_type.add("Open Document Spreadsheet");
		this.spreadsheet_type.add("Tabulated text");
		this.spreadsheet_type.select(0);
		if (conf.get_export_txt()) {
			this.spreadsheet_type.select(1);
		}

		spreadsheet_type.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				logger.debug("Change SpreadSheetType index ");
				Export_Windows.this.updateSpreadsheetType();
			}
		});
	}

	protected void updateSpreadsheetType() {
		if (Export_Windows.this.spreadsheet_type.getEnabled()) {
			conf.set_export_ods(true);
			conf.set_export_txt(false);
			int index = Export_Windows.this.spreadsheet_type
					.getSelectionIndex();
			logger.debug("SpreadSheetType index :" + index);
			if (index == 1) {
				conf.set_export_txt(true);
				conf.set_export_ods(false);
			}
		} else {
			conf.set_export_ods(false);
			conf.set_export_txt(false);
		}
	}

	private void defined_fasta_export_combo() {
		print_fasta_to_group group = new print_fasta_to_group();
		print_fasta_to_subgroup sub = new print_fasta_to_subgroup();
		print_fasta fas = new print_fasta();
		fasta_type.add(fas.toString());
		fasta_type.add(sub.toString());
		fasta_type.add(group.toString());
		fasta_type.setData(group.toString(), group);
		fasta_type.setData(sub.toString(), sub);
		fasta_type.setData(fas.toString(), fas);
		fasta_type.select(0);
	}

	protected void next_clic() {
		try {
			logger.debug("next_clic");
			conf.set_Export_fdr(this.choice_fdr_export.getSelection());

			conf.set_export_fasta(this.choice_fasta_export.getSelection());
			conf.set_export_pepnovo(this.choice_pepnovo_export.getSelection());
			conf.set_export_proticdbml(this.choice_protic_export.getSelection());
			conf.set_export_masschroq(this.choice_quantimscpp_export
					.getSelection());
			conf.set_export_expert_spreadsheet(this.choice_expert_spreadsheet_export
					.getSelection());
			// on sauve
			conf.savePropertiestoXml();
			datatype.getPrint().setfileout(out);
			int index = fasta_type.getSelectionIndex();
			if (index >= 0) {
				logger.debug("index >= 0");
				datatype.getPrint().setFasta_type(
						(print_fasta) fasta_type.getData(fasta_type
								.getItem(index)));
			}
			logger.debug("next_clic step 1");
			// on indique que la fenetre n'a pas ete cancel
			this.Cancelled = false;
			// on libere
			shell.dispose();
		} catch (MSMSException e) {
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ e.getMessage());
			messageBox.open();
		} catch (Exception e) {
			StackTraceElement[] f = e.getStackTrace();
			String error = e.getMessage() + "\nat : " + f[0].toString();
			MessageBox messageBox = new MessageBox(shell, SWT.ERROR);
			messageBox
					.setMessage("Problems trying to save the configuration :\n"
							+ error);
			messageBox.open();
			e.printStackTrace();
		}

	}

	public void setFileout(Button widget) {
		FileDialog dlg = new FileDialog(shell, SWT.SAVE | SWT.SINGLE);
		dlg.setFilterPath(conf.getXmlresult().getPath());
		dlg.setFileName("results");
		String S_out = dlg.open();
		if (S_out != null) {
			this.out = new File(S_out);
			((Text) widget.getData("text")).setText(out.getAbsolutePath());
			next.setEnabled(true);
		}
	}

	public File getFileOut() {
		// TODO Auto-generated method stub
		return out;
	}

	public boolean isCancelled() {
		// TODO Auto-generated method stub
		return Cancelled;
	}

}
