package fr.inra.pappso.xtandempipeline.filter_print;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.GroupSet;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.output.FastaOutputStream;

public class print_fasta {
	private static final Logger logger = Logger.getLogger(print_fasta.class);

	protected FastaOutputStream ofasta;

	public print_fasta() {
		logger.info("Print protein to fasta : " + this.toString());
	}

	public void print_group_information(Group group) throws MSMSException {
		for (SubGroup sg : group.getSubGroupSet()) {
			for (HashSampleScanSetProt hprot : sg
					.getHashSampleScanSetProtList()) {
				Match match = (Match) hprot.getGrpProtMatch();
				try {
					ofasta.write(match.get_protein_match());
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}

	public String toString() {
		return ("All proteins");
	}

	public void setOut(FastaOutputStream ofasta) {
		this.ofasta = ofasta;
	}


	public void print(Identification ident) throws MSMSException {
		GroupSet grouping = ident.getGrouping();
		// TODO Auto-generated method stub
		for (Group group : grouping.getGroupList()) {
			this.print_group_information(group);
		}

	}

}
