package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;
import java.util.TreeSet;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MapDb.Peptide;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScan;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSet;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetPhospho;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.grouping.SubGroupSet;
import fr.inra.pappso.xtandempipeline.thread.DataType_Base;

public class swt_table_peptide extends swt_table_base {

	private HashSampleScanSetProt protein;

	private String filter_value;

	private String filtercolumn;

	public swt_table_peptide(Table ta, DataType_Base type) {
		super(ta, type);
		if (this.type.getIs_phosphopeptide()) {
			header = new String[] { "  ", "Sample", "Scan", "Rt", "Charge",
					"Sequence", "Modifs", "Used", "Sub-groups", "E-value",
					"MH+ Theo", "Delta MH+", "Best Position", "All Position" };
			type_column = new int[] { -1,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.INT_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR,
					SortListenerFactory.INT_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.DOUBLE_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR };
		} else {
			header = new String[] { "  ", "Sample", "Scan", "Rt", "Charge",
					"Sequence", "Modifs", "Used", "Sub-groups", "E-value",
					"MH+ Theo", "Delta MH+" };

			type_column = new int[] { -1,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.INT_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR,
					SortListenerFactory.INT_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.STRING_COMPARATOR,
					SortListenerFactory.DOUBLE_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR,
					SortListenerFactory.FLOAT_COMPARATOR };
		}
		color = true;
		filter_value = "";
		filtercolumn = "";
		// filter = "";
		logger.info("View SWT Peptide Table on type :" + type.getType());
	}

	protected boolean set_table_item(Group group) throws Exception {
		boolean filter = false;
		// different sous-groupe
		for (SubGroup sg : group.getSubGroupSet()) {
			if (sg.getHashSampleScanSetProtSet().contains(protein)) {
				filter = true;
			}
		}
		if (!filter)
			return false;

		logger.info("View SWT peptide Table on protein:"
				+ protein.getGrpProtMatch().getGrpProtein().getAccession());

		// filtrage de la table des peptides
		HashSampleScanSet filterPeptideSet = new HashSampleScanSet();
		for (HashSampleScan hash : protein) {
			Peptide pep = (Peptide) protein.getGrpProtMatch()
					.getBestPeptideToHashSampleScan(hash);
			if (this.filtercolumn.equals("Specific")) {
				int size = group.getSubGroupContaining(hash).size();
				if (!this.filter_value.equals("!")) {
					if (size == 1)
						filterPeptideSet.add(hash);
				} else if (size != 1)
					filterPeptideSet.add(hash);
			} else if (this.filtercolumn.equals("Valid")) {
				if (!this.filter_value.equals("!")) {
					if (pep.isValid())
						filterPeptideSet.add(hash);
				} else if (!pep.isValid())
					filterPeptideSet.add(hash);
			} else if ((this.filter_value.equals(""))
					|| (this.filtercolumn.equals(""))) {
				filterPeptideSet.add(hash);
			} else if (this.filtercolumn.equals("Scan")) {
				String sc = "" + hash.getScan();
				if (sc.equals(this.filter_value))
					filterPeptideSet.add(hash);
			} else if (this.filtercolumn.equals("Sequence")) {
				if (pep.getSequence().contains(this.filter_value))
					filterPeptideSet.add(hash);
			} else if (this.filtercolumn.equals("Sample")) {
				if (hash.getGrpMsSample().getSampleName()
						.contains(this.filter_value))
					filterPeptideSet.add(hash);
			} else if (this.filtercolumn.equals("Modifs")) {
				if (pep.get_Modifs_formater().contains(this.filter_value))
					filterPeptideSet.add(hash);
			}
		}

		for (HashSampleScan hash : filterPeptideSet.getHashSampleScanList()) {

			SubGroupSet set = group.getSubGroupContaining(hash);
			ArrayList<SubGroup> sgList = set.getSubGroupList();
			// HashSampleScanSetProt HashProt = sgList.get(0)
			// .getHashSampleScanSetProtList().get(0);
			Match top = (Match) protein.getGrpProtMatch();
			Peptide pep = (Peptide) top.getBestPeptideToHashSampleScan(hash);

			if (color)
				color = false;
			else
				color = true;

			TableItem item = new TableItem(table, SWT.NONE);
			item.setData("peptide", pep);

			item.setChecked(pep.isValid());

			item.setText(0, "");
			item.setText(1, pep.getIdentificationDataSource().getName());
			item.setText(2, "" + pep.get_scan());
			item.setText(3, "" + pep.getRetentionTimeInMinutes());
			item.setText(4, "" + pep.get_charge());
			item.setText(5, "" + pep.getSequence());
			item.setText(6, "" + pep.get_Modifs_formater());
			if (set.size() > 1)
				item.setText(7, "" + set.size() + "/"
						+ group.getSubGroupSet().size());
			else
				item.setText(7, "-");

			boolean second = false;
			StringBuilder S = new StringBuilder();
			for (SubGroup sub : sgList) {
				if (second) {
					S.append(" ");
				}
				S.append(this.get_subgroup_number(group, sub));
				second = true;
			}
			item.setText(8, S.toString());

			item.setText(9, "" + pep.get_evalue());
			item.setText(10, "" + pep.get_mhplus_theo());
			item.setText(11, "" + pep.get_deltamass());

			if (type.getIs_phosphopeptide()) {
				item.setText(12, "" + pep.get_phospho_Modifs_position());
				HashSampleScanSetPhospho phospho = (HashSampleScanSetPhospho) protein;
				TreeSet<Integer> posi = phospho
						.getAllPositionIncluderedon(hash);
				S = new StringBuilder();
				for (Integer pos : posi)
					S.append(pos + " ");
				item.setText(13, S.toString());
			}

			if (!color)
				item.setBackground(table.getDisplay().getSystemColor(
						SWT.COLOR_WIDGET_LIGHT_SHADOW));

		}
		return (true);
	}

	public HashSampleScanSetProt getProtein() {
		return protein;
	}

	public void setProtein(HashSampleScanSetProt protein) {
		this.protein = protein;
	}

	public void setfiltervalue(String text) {
		// TODO Auto-generated method stub
		this.filter_value = text;
	}

	public void setfiltercolumn(String string) {
		// TODO Auto-generated method stub
		this.filtercolumn = string;
	}

}
