/*******************************************************************************
 * Copyright (c) 2015 Olivier Langella <Olivier.Langella@moulon.inra.fr>.
 *
 * This file is part of XTandemPipeline.
 *
 *     XTandemPipeline is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     XTandemPipeline is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with XTandemPipeline.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contributors:
 *     Olivier Langella <Olivier.Langella@moulon.inra.fr>
 ******************************************************************************/
package fr.inra.pappso.xtandempipeline.input.fasta;

import java.io.InputStream;
import java.util.HashSet;

import org.apache.log4j.Logger;

public class FastaReaderAccessionSet implements FastaReader {
	private static final Logger logger = Logger
			.getLogger(FastaReaderAccessionSet.class);
	FastaInputStreamParser parser;

	HashSet<String> accessionSet = new HashSet<String>();

	public FastaReaderAccessionSet() {
	}

	public void parseFastaInputStream(InputStream inputStream) throws Exception {
		parser = new FastaInputStreamParser(this);
		parser.parseFastaInputStream(inputStream);
	}

	public void newFastaSequence(String header, String strSequence)
			throws Exception {
		accessionSet.add(header.split(" ")[0]);
	}

	public HashSet<String> getAccessionSet() {
		return accessionSet;
	}
}
